
#ifndef _HAL_LPC54608
#define _HAL_LPC54608

/* Includes ------------------------------------------------------------------*/
#include <stdint.h>
#include <stdio.h>

#include "fsl_adc.h"
#include "fsl_gpio.h"

#include "hal_lpc54608_configuration.h"
#include "LLHAL_GPIO_impl.h"

/* Defines -------------------------------------------------------------------*/

/*
 * Available number of channels
 */
#ifndef ADC_NB_CHANNELS
#define ADC_NB_CHANNELS 0
#endif

/*
 * Global virtual MCU port
 */
#define HAL_LPC54608_GPIO_PORT_MCU 0

/* Structs -------------------------------------------------------------------*/

/*
 * MCU pin data
 */
typedef struct
{
    int32_t port;
    int32_t pin;
    int8_t adc_rank;
} hal_lpc54608_gpio_data;

/* API -----------------------------------------------------------------------*/

/*
 * Initialize specific implementation data (clocks etc.)
 */
void hal_lpc54608_initialize(void);

/*
 * Fill the structure for the given port and pin
 */
int32_t hal_lpc54608_get_gpio_data(int32_t port, int32_t pin, hal_lpc54608_gpio_data* gpio);

/* EOF -----------------------------------------------------------------------*/

#endif // _HAL_LPC54608
