/*
 * C
 *
 * Copyright 2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#ifndef LLNET_SSL_VERIFY_CALLBACK
#define LLNET_SSL_VERIFY_CALLBACK
#include <sni.h>
#include <wolfssl/internal.h>

#ifdef __cplusplus
	extern "C" {
#endif

/*
 * Verify Callback context
*/
struct VERIFY_CALLBACK_CTX{
	WOLFSSL * ssl;	/*associated SSL*/
	int32_t error; 	/*callback error*/
};

/**
 *  Returns the trusted CA if found, otherwise NULL
 */
static Signer* LLNET_SSL_VERIFY_getTrustedCA(WOLFSSL_CTX* ctx, DecodedCert* cert);

/*
 * Certificate verification callback
*/
int32_t LLNET_SSL_VERIFY_verifyCallback(int32_t previousVerifySuccess, WOLFSSL_X509_STORE_CTX* store);

/**
 * Frees the given signer content
 */
void LLNET_SSL_VERIFY_freeSignerContent(Signer* issuer, void* heap);

/**
 * Fills signer with the given cert infos
 */
void LLNET_SSL_VERIFY_decodedCertAsSigner(Signer* issuer, DecodedCert* cert);

/**
 * Validates the given certificate by verifying basic constraints, name constraints, name chaining and signature
 */
int32_t LLNET_SSL_VERIFY_validateCertChain(Signer* issuer, DecodedCert* dCert, uint8_t intermediateCert);

#ifdef __cplusplus
	}
#endif

#endif
