/* 
 * C
 * 
 * Copyright 2014-2016 IS2T. All rights reserved.
 * Modification and distribution is permitted under certain conditions.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
/* 
 * AUTOGENERATED by COMP-ICETEA-CIAR-ARM - 1.0.0 - DO NOT EDIT IT
 */
/**
 * Dispatch Event Low Level APIs
 */
#ifndef _LLDISPATCH_EVENT
#define _LLDISPATCH_EVENT 
#include <intern\LLDISPATCH_EVENT.h>
#include <stdint.h>
#ifdef __cplusplus
	extern "C" {
#endif
// --------------------------------------------------------------------------------
// -                      Functions provided by the platform                      -
// --------------------------------------------------------------------------------

/**
 * Adds a new blocking request associated with the given socket file descriptor fd, the java thread ID 
 * and the request kind to the dispatch pending request queue.
 * Once the request is added, the specified java thread is suspended during the specified delay and
 * {@link LLDISPATCH_wakeUpWaitForOperation} function is called to unblock the dispatch event thread
 * if it is waiting on {@link LLDISPATCH_waitForOperation}.
 * The new request is took account in the process by the next call of {@link LLDISPATCH_waitForOperation}.
 * @param fd the socket file descriptor
 * @param javaThreadID the request java thread ID
 * @param kind the request kind ({@link Constants#REQUEST_READ or Constants#REQUEST_WRITE}
 * @param delay the request timeout (0 for infinite timeout)
 * @return true on success, false otherwise
 */
uint8_t LLDISPATCH_EVENT_addBlockingRequest(int32_t fd, int32_t javaThreadID, int32_t kind, int32_t delay);

/**
 * Checks if a blocking request is already exist with the given socket file descriptor fd, the specified java thread ID 
 * and the request kind
 * @param fd the socket file descriptor
 * @param javaThreadID the request java thread ID
 * @param kind the request kind ({@link Constants#REQUEST_READ or Constants#REQUEST_WRITE}
 * @return true if a blocking request is already exist with the given socket file descriptor fd,
 * the specified java thread ID and request kind; false otherwise
 */
uint8_t LLDISPATCH_EVENT_existingBlockingRequest(int32_t fd, int32_t javaThreadID, int32_t kind);

#ifdef __cplusplus
	}
#endif
#endif
