/* 
 * C
 * 
 * Copyright 2014-2016 IS2T. All rights reserved.
 * Modification and distribution is permitted under certain conditions.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
/* 
 * AUTOGENERATED by COMP-ICETEA-CIAR-ARM - 1.0.0 - DO NOT EDIT IT
 */
/* 
 * Implementation header file. Shall only be included by client implementation C files.
 */
#include <stdint.h>
#include <intern\LLDISPATCH_impl.h>
// --------------------------------------------------------------------------------
// -                      Functions that must be implemented                      -
// --------------------------------------------------------------------------------

/**
 * Enters in a critical session.
 */
void LLDISPATCH_IMPL_lock(void);

/**
 * Leaves a critical session.
 */
void LLDISPATCH_IMPL_unlock(void);

/**
 * Creates and starts the dispatch event thread.
 * The created dispatch event thread starts execution by invoking the given method argument.
 */
void LLDISPATCH_IMPL_startThread(void* method);

/**
 * Unblocks the dispatch event thread if it is waiting on {@link LLDISPATCH_waitForOperation} function
 */
void LLDISPATCH_IMPL_wakeUpWaitForOperation(void);

/**
 * Blocks the dispatch event thread until one or more file descriptors in the {@code fds} array become ready 
 * for a read or write operation without blocking.
 * The set of file descriptors is updated : reset to 0 if no incoming operation on it and the {@code fdsPtr} is set to -1.
 * Each file descriptor has its associated operation kind at the same index-position in fdOperation arrays
 * @param fds the file descriptors set
 * @param fdOperations the request operation kinds set
 * @param fdsPtr the number of file descriptors in the fds set; -1 if no file file descriptors
 * @return {@link LLDISPATCH_CONSTANTS_WAIT_FOR_OPERATION_SUCCEED} when an operation is available on at least one of the file descriptors; 
 * or {@link LLDISPATCH_CONSTANTS_WAIT_FOR_OPERATION_INTERRUPTED} if it has been unblocked from {@link LLDISPATCH_wakeUpWaitForOperation} 
 */
int32_t LLDISPATCH_IMPL_waitForOperation(int32_t* fds, int32_t* fdOperations, int32_t fdsPtr);

/**
 * When the {@link LLDISPATCH_waitForOperation} function returned {@link LLDISPATCH_CONSTANTS_WAIT_FOR_OPERATION_SUCCEED}, 
 * this method is called to check if the given file descriptor is ready for the specified operation.
 * On success, all waiting java thread associated with this file descriptor and operation in a blocking request are notified and resumed.
 * @param fd the file descriptor
 * @param operation the request operation kind
 * @return true if the given file descriptor is read for the specified operation kind, false otherwise
 */
uint8_t LLDISPATCH_IMPL_isReadyForOperation(int32_t fd, int32_t operation);
