/*
* C
*
* Copyright 2015 IS2T. All rights reserved.
* For demonstration purpose only.
* IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
*/
#include "fsl_rng.h"
#include "fsl_clock.h"
#include "fsl_power.h"

#include "LLNET_Cfg.h"

/**
* Returns a 32 bit random number.
*/
uint32_t LLNET_getRandomNumber(){

    uint32_t number;
    uint32_t skip;

    /* The clock & power for the random number generator are taken care by the ROM API */
    /*
     * POWER_DisablePD(kPDRUNCFG_PD_rng);
     * CLOCK_EnableClock(kCLOCK_Rng);
     * RESET_PeripheralReset(kRNG_RST_SHIFT_RSTn);
     */

    number = RNG_GetRandomData();

    /* Skip next 32 random numbers for better entropy */
    for (skip = 0; skip < 32; skip++)
    {
        RNG_GetRandomData();
    }
    return number;

}
