/*
 * C
 *
 * Copyright 2015-2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include <LLNET_SSL_ERRORS.h>
#include <wolfssl/ssl.h>
#include <wolfssl/error-ssl.h>
#include <sni.h>

/* Private defines -----------------------------------------------------------*/

/* Temporary(until a new NET pack is released) */
#define J_ASYNC_INIT_ERROR J_CAVIUM_INIT_ERROR
#define J_BAD_STATE_ERROR J_BAD_ENC_STATE_ERROR

#ifdef __cplusplus
	extern "C" {
#endif
		
jint LLNET_SSL_TranslateReturnCode(int32_t wolfSSL_error) {

	switch (wolfSSL_error) {

	case SSL_SUCCESS:
		return J_SSL_NO_ERROR;

	case OPEN_RAN_E:
		return J_OPEN_RAN_ERROR;

	case READ_RAN_E:
		return J_READ_RAN_ERROR;

	case WINCRYPT_E:
		return J_WINCRYPT_ERROR;

	case CRYPTGEN_E:
		return J_CRYPTGEN_ERROR;

	case RAN_BLOCK_E:
		return J_RAN_BLOCK_ERROR;

	case RSA_WRONG_TYPE_E:
		return J_RSA_WRONG_TYPE_ERROR;

	case RSA_BUFFER_E:
		return J_RSA_BUFFER_ERROR;

	case BUFFER_E:
		return J_BUFFER_ERROR;

	case ALGO_ID_E:
		return J_ALGO_ID_ERROR;

	case PUBLIC_KEY_E:
		return J_PUBLIC_KEY_ERROR;

	case DATE_E:
		return J_DATE_ERROR;

	case SUBJECT_E:
		return J_SUBJECT_ERROR;

	case ISSUER_E:
		return J_ISSUER_ERROR;

	case CA_TRUE_E:
		return J_CA_TRUE_ERROR;

	case EXTENSIONS_E:
		return J_EXTENSIONS_ERROR;

	case ASN_PARSE_E:
		return J_CERT_PARSE_ERROR;

	case ASN_VERSION_E:
		return J_ASN_VERSION_ERROR;

	case ASN_GETINT_E:
		return J_ASN_GETINT_ERROR;

	case ASN_RSA_KEY_E:
		return J_ASN_RSA_KEY_ERROR;

	case ASN_OBJECT_ID_E:
		return J_ASN_OBJECT_ID_ERROR;

	case ASN_TAG_NULL_E:
		return J_ASN_TAG_NULL_ERROR;

	case ASN_EXPECT_0_E:
		return J_ASN_EXPECT_0_ERROR;

	case ASN_BITSTR_E:
		return J_ASN_BITSTR_ERROR;

	case ASN_UNKNOWN_OID_E:
		return J_ASN_UNKNOWN_OID_ERROR;

	case ASN_DATE_SZ_E:
		return J_ASN_DATE_SZ_ERROR;

	case ASN_BEFORE_DATE_E:
		return J_ASN_BEFORE_DATE_ERROR;

	case ASN_AFTER_DATE_E:
		return J_ASN_AFTER_DATE_ERROR;

	case ASN_SIG_OID_E:
		return J_ASN_SIG_OID_ERROR;

	case ASN_TIME_E:
		return J_ASN_TIME_ERROR;

	case ASN_INPUT_E:
		return J_ASN_INPUT_ERROR;

	case ASN_SIG_CONFIRM_E:
		return J_ASN_SIG_CONFIRM_ERROR;

	case ASN_SIG_HASH_E:
		return J_ASN_SIG_HASH_ERROR;

	case ASN_SIG_KEY_E:
		return J_ASN_SIG_KEY_ERROR;

	case ASN_DH_KEY_E:
		return J_ASN_DH_KEY_ERROR;

	case ASN_NTRU_KEY_E:
		return J_ASN_NTRU_KEY_ERROR;

	case ASN_CRIT_EXT_E:
		return J_ASN_CRIT_EXT_ERROR;

	case ECC_BAD_ARG_E:
		return J_ECC_BAD_ARG_ERROR;

	case ASN_ECC_KEY_E:
		return J_ASN_ECC_KEY_ERROR;

	case ECC_CURVE_OID_E:
		return J_ECC_CURVE_OID_ERROR;

	case BAD_FUNC_ARG:
		return J_BAD_FUNC_ARG;

	case NOT_COMPILED_IN:
		return J_NOT_COMPILED_IN;

	case UNICODE_SIZE_E:
		return J_UNICODE_SIZE_ERROR;

	case NO_PASSWORD:
		return J_NO_PASSWORD;

	case ALT_NAME_E:
		return J_ALT_NAME_ERROR;

	case AES_GCM_AUTH_E:
		return J_AES_CCM_AUTH_ERROR;

	case AES_CCM_AUTH_E:
		return J_AES_CCM_AUTH_ERROR;

	case CAVIUM_INIT_E:
		return J_ASYNC_INIT_ERROR;

	case BAD_ALIGN_E:
		return J_BAD_ALIGN_ERROR;

	case ASN_NO_SIGNER_E:
		return J_ASN_NO_SIGNER_ERROR;

	case ASN_CRL_CONFIRM_E:
		return J_ASN_CRL_CONFIRM_ERROR;

	case ASN_CRL_NO_SIGNER_E:
		return J_ASN_CRL_NO_SIGNER_ERROR;

	case ASN_OCSP_CONFIRM_E:
		return J_ASN_OCSP_CONFIRM_ERROR;

	case BAD_ENC_STATE_E:
		return J_BAD_STATE_ERROR;

	case BAD_PADDING_E:
		return J_BAD_PADDING_ERROR;

	case REQ_ATTRIBUTE_E:
		return J_REQ_ATTRIBUTE_ERROR;

	case PKCS7_OID_E:
		return J_PKCS7_OID_ERROR;

	case PKCS7_RECIP_E:
		return J_PKCS7_RECIP_ERROR;

	case FIPS_NOT_ALLOWED_E:
		return J_FIPS_NOT_ALLOWED_ERROR;

	case ASN_NAME_INVALID_E:
		return J_ASN_NAME_INVALID_ERROR;

	case RNG_FAILURE_E:
		return J_RNG_FAILURE_ERROR;

	case HMAC_MIN_KEYLEN_E:
		return J_HMAC_MIN_KEYLEN_ERROR;

	case RSA_PAD_E:
		return J_RSA_PAD_ERROR;

	case LENGTH_ONLY_E:
		return J_LENGTH_ONLY_ERROR;

	case IN_CORE_FIPS_E:
		return J_IN_CORE_FIPS_ERROR;

	case AES_KAT_FIPS_E:
		return J_AES_KAT_FIPS_ERROR;

	case DES3_KAT_FIPS_E:
		return J_DES3_KAT_FIPS_ERROR;

	case HMAC_KAT_FIPS_E:
		return J_HMAC_KAT_FIPS_ERROR;

	case RSA_KAT_FIPS_E:
		return J_RSA_KAT_FIPS_ERROR;

	case DRBG_KAT_FIPS_E:
		return J_DRBG_KAT_FIPS_ERROR;

	case DRBG_CONT_FIPS_E:
		return J_DRBG_CONT_FIPS_ERROR;

	case AESGCM_KAT_FIPS_E:
		return J_AESGCM_KAT_FIPS_ERROR;
	case UNSUPPORTED_SUITE:
		return J_UNSUPPORTED_SUITE;

	case INPUT_CASE_ERROR:
		return J_INPUT_CASE_ERROR;

	case PREFIX_ERROR:
		return J_PREFIX_ERROR;

	case MEMORY_ERROR:
	case MEMORY_E:
		return J_MEMORY_ERROR;

	case VERIFY_FINISHED_ERROR:
		return J_VERIFY_FINISHED_ERROR;

	case VERIFY_MAC_ERROR:
		return J_VERIFY_MAC_ERROR;

	case PARSE_ERROR:
		return J_HEADER_PARSE_ERROR;
	
	case SIDE_ERROR:
		return J_SIDE_ERROR;

	case NO_PEER_CERT:
		return J_NO_PEER_CERT;

	case UNKNOWN_HANDSHAKE_TYPE:
		return J_UNKNOWN_HANDSHAKE_TYPE;

	case SOCKET_ERROR_E:
		return J_SOCKET_ERROR;

	case SOCKET_NODATA:
		return J_SOCKET_NODATA;

	case INCOMPLETE_DATA:
		return J_INCOMPLETE_DATA;

	case UNKNOWN_RECORD_TYPE:
		return J_UNKNOWN_RECORD_TYPE;

	case DECRYPT_ERROR:
		return J_DECRYPT_ERROR;

	case FATAL_ERROR:
	case SSL_FATAL_ERROR:
		return J_FATAL_ERROR;

	case ENCRYPT_ERROR:
		return J_ENCRYPT_ERROR;

	case NO_PEER_KEY:
		return J_NO_PEER_KEY;

	case NO_PRIVATE_KEY:
		return J_NO_PRIVATE_KEY;

	case NO_DH_PARAMS:
		return J_NO_DH_PARAMS;

	case RSA_PRIVATE_ERROR:
		return J_RSA_PRIVATE_ERROR;

	case MATCH_SUITE_ERROR:
		return J_MATCH_SUITE_ERROR;

	case BUILD_MSG_ERROR:
		return J_BUILD_MSG_ERROR;

	case BAD_HELLO:
		return J_BAD_HELLO;

	case DOMAIN_NAME_MISMATCH:
		return J_DOMAIN_NAME_MISMATCH;

	case WANT_READ:
	case SSL_ERROR_WANT_READ:
		return J_WANT_READ;

	case NOT_READY_ERROR:
		return J_NOT_READY_ERROR;

	case PMS_VERSION_ERROR:
		return J_PMS_VERSION_ERROR;

	case VERSION_ERROR:
		return J_VERSION_ERROR;

	case WANT_WRITE:
	case SSL_ERROR_WANT_WRITE:
		return J_WANT_WRITE;

	case BUFFER_ERROR:
		return J_MALFORMED_BUFFER;

	case VERIFY_CERT_ERROR:
		return J_VERIFY_CERT_ERROR;

	case VERIFY_SIGN_ERROR:
		return J_VERIFY_SIGN_ERROR;

	case CLIENT_ID_ERROR:
		return J_CLIENT_ID_ERROR;

	case SERVER_HINT_ERROR:
		return J_SERVER_HINT_ERROR;

	case PSK_KEY_ERROR:
		return J_PSK_KEY_ERROR;

	case NTRU_KEY_ERROR:
		return J_NTRU_KEY_ERROR;

	case NTRU_DRBG_ERROR:
		return J_NTRU_DRBG_ERROR;

	case NTRU_ENCRYPT_ERROR:
		return J_NTRU_ENCRYPT_ERROR;

	case NTRU_DECRYPT_ERROR:
		return J_NTRU_DECRYPT_ERROR;

	case LENGTH_ERROR:
		return J_LENGTH_ERROR;

	case PEER_KEY_ERROR:
		return J_PEER_KEY_ERROR;

	case ZERO_RETURN:
	case SSL_ERROR_ZERO_RETURN:
		// Return J_EOF due to a bug in the upper Java library. See https://youtrack.cross/issue/P0046STM32F746DISCO-16
		// Workaround to be removed once a proper solution will be implemented
		//return J_ZERO_RETURN;
		return J_EOF;

	case ECC_CURVETYPE_ERROR:
		return J_ECC_CURVETYPE_ERROR;

	case ECC_CURVE_ERROR:
		return J_ECC_CURVE_ERROR;

	case ECC_PEERKEY_ERROR:
		return J_ECC_PEERKEY_ERROR;

	case ECC_MAKEKEY_ERROR:
		return J_ECC_MAKEKEY_ERROR;

	case ECC_EXPORT_ERROR:
		return J_ECC_EXPORT_ERROR;

	case ECC_SHARED_ERROR:
		return J_ECC_SHARED_ERROR;

	case NOT_CA_ERROR:
		return J_NOT_CA_ERROR;

	case BAD_CERT_MANAGER_ERROR:
		return J_BAD_CERT_MANAGER_ERROR;

	case OCSP_CERT_REVOKED:
		return J_OCSP_CERT_REVOKED;

	case CRL_CERT_REVOKED:
		return J_CRL_CERT_REVOKED;

	case CRL_MISSING:
		return J_CRL_MISSING;

	case OCSP_NEED_URL:
		return J_OCSP_NEED_URL;

	case OCSP_CERT_UNKNOWN:
		return J_OCSP_CERT_UNKNOWN;

	case OCSP_LOOKUP_FAIL:
		return J_OCSP_LOOKUP_FAIL;

	case MAX_CHAIN_ERROR:
		return J_MAX_CHAIN_ERROR;

	case SUITES_ERROR:
		return J_SUITES_ERROR;

	case SSL_NO_PEM_HEADER:
		return J_SSL_NO_PEM_HEADER;

	case OUT_OF_ORDER_E:
		return J_OUT_OF_ORDER_ERROR;

	case BAD_KEA_TYPE_E:
		return J_BAD_KEA_TYPE_ERROR;

	case SANITY_CIPHER_E:
		return J_SANITY_CIPHER_ERROR;

	case RECV_OVERFLOW_E:
		return J_RECV_OVERFLOW_ERROR;

	case NO_PEER_VERIFY:
		return J_NO_PEER_VERIFY;

	case UNKNOWN_SNI_HOST_NAME_E:
		return J_UNKNOWN_HOST_NAME_ERROR;

	case KEYUSE_SIGNATURE_E:
		return J_KEYUSE_SIGNATURE_ERROR;

	case KEYUSE_ENCIPHER_E:
		return J_KEYUSE_ENCIPHER_ERROR;

	case EXTKEYUSE_AUTH_E:
		return J_EXTKEYUSE_AUTH_ERROR;

	case SEND_OOB_READ_E:
		return J_SEND_OOB_READ_ERROR;

	case SECURE_RENEGOTIATION_E:
		return J_SECURE_RENEGOTIATION_ERROR;

	case SCR_DIFFERENT_CERT_E:
		return J_SCR_DIFFERENT_CERT_ERROR;

	case NO_CHANGE_CIPHER_E:
		return J_NO_CHANGE_CIPHER_ERROR;

	case SANITY_MSG_E:
		return J_SANITY_MSG_ERROR;

	case DUPLICATE_MSG_E:
		return J_DUPLICATE_MSG_ERROR;

	case SSL_BAD_CERTTYPE :
		return J_BAD_CERTTYPE;
	
	case SSL_BAD_FILETYPE :
		return J_BAD_ENCODED_CERT_FORMAT;

	case SSL_UNKNOWN:
	default:
		return J_UNKNOWN_ERROR;
	}

}

#ifdef __cplusplus
	}
#endif
